//////////////////////////////////////////////////////////////////////
// Simple consol print demo
// -- dovoto
//////////////////////////////////////////////////////////////////////

#include <NDS/NDS.h>

#include <NDS/ARM9/console.h> //basic print funcionality

extern "C"	// Stuff from SpeedTest.s
{
	extern int cycleTimes[];	// Time taken by each test
	extern int testCount;		// Number of tests that were performed
	extern void SpeedTest();
}

int main(void)
{
	videoSetMode(0); //not using the main screen
	videoSetModeSub(MODE_0_2D | DISPLAY_BG0_ACTIVE); //sub bg 0 will be used to print text
	vramSetBankC(VRAM_C_SUB_BG); 

	SUB_BG0_CR = BG_MAP_BASE(31);
	
	BG_PALETTE_SUB[255] = RGB15(31,31,31);//by default font will be rendered with color 255
	
	//consoleInit() is a lot more flexible but this gets you up and running quick
	consoleInitDefault((u16*)SCREEN_BASE_BLOCK_SUB(31), (u16*)CHAR_BASE_BLOCK_SUB(0), 16);

	consolePrintSet(1,1);
	consolePrintf("ARM9 speed test by DekuTree64\n");

	SpeedTest();

	for (int i = 0; i < testCount; i++)
	{
		consolePrintf("Test %i: %i cycles\n", i+1, cycleTimes[i]);
	}
	
	while(1)
	{
			// So you can make sure it's not locked up...
		BG_PALETTE_SUB[0] = IPC->touchX * IPC->touchY;	
	
	}
	return 0;
}
